Attribute VB_Name = "modMain"
Option Explicit

'API Types
Public Type SHITEMID
   cb             As Long
   abID           As Byte
End Type

Public Type ITEMIDLIST
   mkid           As SHITEMID
End Type

Public Type BROWSEINFO
   hOwner         As Long
   pidlRoot       As Long
   pszDisplayName As String
   lpszTitle      As String
   ulFlags        As Long
   lpfn           As Long
   lParam         As Long
   iImage         As Long
End Type

'API Constants
Public Const BIF_RETURNONLYFSDIRS = &H1

'API Functions
Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias _
                "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Declare Function SHBrowseForFolder Lib "shell32.dll" Alias _
                "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

'Public variables
Public objServer As New SQLDMO.SQLServer
Public strServerNameSW As String
Public strLoginSW As String
Public bLoginSecureSW As Boolean
Public strPasswordSW As String
Public vDatabasesSW As Variant
Public strDestDirSW As String
Public bDelOldFilesSW As Boolean
Public iDelWeeksSW As Integer
Public bSaveDTSPackagesSW As Boolean
Public bScriptAlertsSW As Boolean
Public bScriptServerLoginsSW As Boolean
Public bScriptAgentJobsSW As Boolean
Public bScriptBackupDevicesSW As Boolean
Public bRunUnAttendedSW As Boolean

Public bNoGUI As Boolean
Public strUnattendedLog As String
Public strLogFile As String


Public Function BrowseForFolder(szPrompt As String) As String
   Dim biInfo As BROWSEINFO
   Dim pidl As Long
   Dim szPath As String
   
   szPath = Space$(512)
   
   biInfo.hOwner = 0&
   biInfo.pidlRoot = 0&
   biInfo.lpszTitle = szPrompt
   biInfo.ulFlags = BIF_RETURNONLYFSDIRS
   
   pidl = SHBrowseForFolder(biInfo)
   SHGetPathFromIDList ByVal pidl, ByVal szPath
   
   BrowseForFolder = Trim$(szPath)
End Function

Public Sub SaveLog(ByVal strLogFile As String)
    Dim iFileNumber As Integer
    
    On Error Resume Next
    iFileNumber = FreeFile
    Open strLogFile For Output As #iFileNumber
    Print #iFileNumber, strUnattendedLog
    Close #iFileNumber
    DoEvents
End Sub

Public Function StatusMessage(ByVal strMessage As String) As String
    Const ciMaxVisualLogLength As Integer = 30000
    Const cstrLogDateTimeFormat As String = "yyyymmdd Hh:Mm:Ss"
    
    Dim strLogEntry As String
    Dim iPos As Integer
    
    On Error Resume Next
    StatusMessage = strMessage
    strLogEntry = Format(Now, cstrLogDateTimeFormat) & vbTab & strMessage
    strUnattendedLog = strUnattendedLog & strLogEntry & vbNewLine
    If Not bNoGUI Then
        With frmMain.lblStatus
            .Caption = " " & strMessage
            .Refresh
        End With
        If Len(strUnattendedLog) > ciMaxVisualLogLength Then
            iPos = InStr(Right$(strUnattendedLog, ciMaxVisualLogLength), vbNewLine)
            With frmMain.txtLog
                .Text = Right$(strUnattendedLog, ciMaxVisualLogLength - iPos - 1)
                .SelStart = Len(.Text)
                .Refresh
            End With
        Else
            With frmMain.txtLog
                .Text = strUnattendedLog
                .SelStart = Len(.Text)
                .Refresh
            End With
        End If
    End If
End Function

Public Sub GenerateScripts(strServerName As String, _
                           strDir As String, _
                           Optional vDatabases As Variant, _
                           Optional bTrustedConnection As Boolean = True, Optional strLogin As String, Optional strPassword As String, _
                           Optional bDelOldFiles As Boolean = False, Optional iDelWeeks As Integer = 4, _
                           Optional bScriptDBTables As Boolean = True, _
                           Optional bScriptDBViews As Boolean = True, _
                           Optional bScriptDBSPs As Boolean = True, _
                           Optional bScriptDBRules As Boolean = True, _
                           Optional bScriptDBDefaults As Boolean = True, _
                           Optional bScriptDBRoles As Boolean = True, _
                           Optional bScriptDBFullText As Boolean = True, _
                           Optional bScriptDBUsers As Boolean = True, _
                           Optional bScriptDBUDTs As Boolean = True, _
                           Optional bSaveDTSPackages As Boolean = False, _
                           Optional bScriptAlerts As Boolean = False, _
                           Optional bScriptAgentJobs As Boolean = False, _
                           Optional bScriptServerLogins As Boolean = False, _
                           Optional bScriptBackupDevices As Boolean = False)

    Const cScriptOptions = SQLDMOScript_Default Or SQLDMOScript_Drops Or _
                           SQLDMOScript_IncludeHeaders Or SQLDMOScript_Permissions Or _
                           SQLDMOScript_OwnerQualify
    Const cTableScriptOptions = cScriptOptions Or SQLDMOScript_Indexes Or SQLDMOScript_Triggers Or _
                                SQLDMOScript_DRI_All Or SQLDMOScript_Bindings
    
    
    Dim objLogin As SQLDMO.Login
    Dim objDatabase As SQLDMO.Database
    Dim objCatalog As SQLDMO.FullTextCatalog
    Dim objTab As SQLDMO.Table
    Dim objView As SQLDMO.View
    Dim objProc As SQLDMO.StoredProcedure
    Dim objRule As SQLDMO.Rule
    Dim objDefault As SQLDMO.Default
    Dim objUser As SQLDMO.User
    Dim objRole As SQLDMO.DatabaseRole
    Dim objUDT As SQLDMO.UserDefinedDatatype
    Dim objBackupDevice As SQLDMO.BackupDevice
    Dim qryResults As SQLDMO.QueryResults
    Dim objPackage As DTS.Package
    Dim strScript As String, strScript2 As String
    Dim strYYYYMMDD As String, strDelCommand As String, strFile As String
    Dim strSQLquery As String, strPackageFile As String
    Dim i As Integer, i2 As Integer, j As Integer, iFileNumber As Integer
    Dim dtDelDate As Date
    Dim msgResult As VbMsgBoxResult
    Dim strCheckPoint As String
    Dim strPackageName As String
    
    strYYYYMMDD = Format(Date, "yyyymmdd")
    
    'Deleting old files
    If bDelOldFiles Then
        strCheckPoint = "deleting"
        On Error Resume Next
        StatusMessage "Deleting old files in [" & strDir & "]:"
        dtDelDate = DateAdd("ww", -iDelWeeks, Date)
        If InStr(strDir, ":") > 0 Then ChDrive Left$(Trim$(strDir), 1)
        ChDir strDir
        strFile = Dir("*.*")
        i = 0
        While Len(strFile) <> 0
            If DateValue(FileDateTime(strFile)) <= dtDelDate Then
                i = i + 1
                Kill strFile
                StatusMessage "- Deleted file " & CStr(i) & ": " & strFile
                DoEvents
            End If
            strFile = Dir
        Wend
        StatusMessage "* " & CStr(i) & " old files deleted."
    End If
    
    'Save DTS Packages
    On Error GoTo ErrorHandler
    If objServer.Issysadmin And bSaveDTSPackages Then
        strCheckPoint = "dts"
        StatusMessage "Saving DTS packages as Structured Storage Files:"
        Set qryResults = objServer.ExecuteWithResults("USE msdb SELECT DISTINCT name FROM sysdtspackages")
        With qryResults
            For i = 1 To .Rows
                strPackageName = .GetColumnString(i, 1)
                StatusMessage "- Saving DTS package " & CStr(i) & ": " & strPackageName
                Set objPackage = New DTS.Package
                If objServer.LoginSecure Then
                    objPackage.LoadFromSQLServer ServerName:=strServerName, PackageName:=strPackageName, Flags:=DTSSQLStgFlag_UseTrustedConnection
                Else
                    objPackage.LoadFromSQLServer ServerName:=strServerName, ServerUserName:=strLoginSW, ServerPassword:=strPasswordSW, PackageName:=strPackageName
                End If
                DoEvents
                strPackageFile = strDir & strYYYYMMDD & "." & strPackageName & ".dts"
                objPackage.SaveToStorageFile strPackageFile
                DoEvents
NextDTSPackage:
                objPackage.UnInitialize
                Set objPackage = Nothing
            Next i
        End With
        StatusMessage "* " & CStr(i - 1) & " DTS packages saved."
        DoEvents
    End If

    'Script Operators/Alerts
    If objServer.Issysadmin And bScriptAlerts Then
        strCheckPoint = "alerts"
        StatusMessage "Generating script for Operators and Alerts:"
        strScript = objServer.JobServer.Operators.Script(ScriptType:=cScriptOptions)
        DoEvents
        strScript2 = objServer.JobServer.Alerts.Script(ScriptType:=cScriptOptions, Script2Type:=SQLDMOScript2_AgentNotify)
        DoEvents
        iFileNumber = FreeFile
        strFile = strDir & strYYYYMMDD & "." & strServerName & "_Alerts.sql"
        Open strFile For Output As #iFileNumber
        Print #iFileNumber, strScript
        DoEvents
        Print #iFileNumber, strScript2
        DoEvents
        Close #iFileNumber
        i = objServer.JobServer.Alerts.Count
        i2 = objServer.JobServer.Operators.Count
        StatusMessage "* " & CStr(i2) & " Operators and " & CStr(i) & " Alerts scripted."
        DoEvents
    End If
    
    'Script SQL Agent Jobs
    If objServer.Issysadmin And bScriptAgentJobs Then
        strCheckPoint = "jobs"
        StatusMessage "Generating script for SQL Agent Jobs:"
        strScript = objServer.JobServer.Jobs.Script(ScriptType:=cScriptOptions)
        DoEvents
        iFileNumber = FreeFile
        strFile = strDir & strYYYYMMDD & "." & strServerName & "_Jobs.sql"
        Open strFile For Output As #iFileNumber
        Print #iFileNumber, strScript
        DoEvents
        Close #iFileNumber
        i = objServer.JobServer.Jobs.Count
        StatusMessage "* " & CStr(i) & " SQL Agent Jobs scripted."
        DoEvents
    End If
    
    'Script Server Logins
    If objServer.Issysadmin And bScriptServerLogins Then
        strCheckPoint = "logins"
        StatusMessage "Generating script for Server Logins:"
        iFileNumber = FreeFile
        strFile = strDir & strYYYYMMDD & "." & strServerName & "_Logins.sql"
        Open strFile For Output As #iFileNumber
        i = 0
        For Each objLogin In objServer.Logins
            i = i + 1
            StatusMessage "- Generating T-SQL code for Server Login " & CStr(i) & ": " & objLogin.Name
            strScript = objLogin.Script(ScriptType:=cScriptOptions, Script2Type:=SQLDMOScript2_LoginSID)
            DoEvents
            Print #iFileNumber, strScript
            DoEvents
        Next objLogin
        Close #iFileNumber
        StatusMessage "* " & CStr(i) & " Server Logins scripted."
        DoEvents
    End If
    
    'Script Backup Devices
    If objServer.Issysadmin And bScriptBackupDevices Then
        strCheckPoint = "backupdevices"
        StatusMessage "Generating script for Backup Devices:"
        iFileNumber = FreeFile
        strFile = strDir & strYYYYMMDD & "." & strServerName & "_BackupDevices.sql"
        Open strFile For Output As #iFileNumber
        i = 0
        For Each objBackupDevice In objServer.BackupDevices
            i = i + 1
            StatusMessage "- Generating T-SQL code for Backup Device " & CStr(i) & ": " & objBackupDevice.Name
            strScript = objBackupDevice.Script(ScriptType:=cScriptOptions)
            DoEvents
            Print #iFileNumber, strScript
            DoEvents
        Next objBackupDevice
        Close #iFileNumber
        StatusMessage "* " & CStr(i) & " Backup Devices scripted."
        DoEvents
    End If
    
    'Script Databases
    If Not IsMissing(vDatabases) Then
        strCheckPoint = "databases"
        i = 0
        StatusMessage "Generating scripts for Databases:"
        
        For Each objDatabase In objServer.Databases
        
            Select Case UCase$(vDatabases(0))
                Case "ALL"
                    GoTo ScriptDatabase
                Case "SYSTEM"
                    If objDatabase.SystemObject Then
                        GoTo ScriptDatabase
                    Else
                        GoTo NextDatabase
                    End If
                Case "USER"
                    If objDatabase.SystemObject Then
                        GoTo NextDatabase
                    Else
                        GoTo ScriptDatabase
                    End If
                Case Else
                    For j = 0 To UBound(vDatabases)
                        If UCase$(vDatabases(j)) = UCase$(objDatabase.Name) Then
                            GoTo ScriptDatabase
                        End If
                    Next j
                    GoTo NextDatabase
            End Select
                
ScriptDatabase:
            'Script the Database
            i = i + 1
            StatusMessage "- Generating T-SQL code for Database " & CStr(i) & ": " & objDatabase.Name
'            Set objDatabase = objServer.Databases(vDatabases(j))
            DoEvents
            strScript = objDatabase.Script(ScriptType:=cScriptOptions)
            DoEvents
            iFileNumber = FreeFile
            strFile = strDir & strYYYYMMDD & "." & objDatabase.Name & "_Database.sql"
            Open strFile For Output As #iFileNumber
            Print #iFileNumber, strScript
            DoEvents
            If bScriptDBFullText Then
                'Script the FullText catalogs
                StatusMessage "  - Generating scripts for FullText Catalogs:"
                i2 = 0
                For Each objCatalog In objDatabase.FullTextCatalogs
                    i2 = i2 + 1
                    StatusMessage "    - Generating T-SQL code for FullText Catalog " & CStr(i2) & ": " & objCatalog.Name
                    strScript = objCatalog.Script(ScriptType:=cScriptOptions, Script2Type:=SQLDMOScript2_FullTextCat)
                    Print #iFileNumber, strScript
                    Print #iFileNumber, "GO"
                    DoEvents
                Next objCatalog
                StatusMessage "  * " & CStr(i2) & " FullText Catalogs scripted."
                DoEvents
            End If
            Close #iFileNumber
            
            If bScriptDBTables Then
                'Script Tables, Indexes and Triggers
                StatusMessage "  - Generating scripts for Tables, Indexes and Triggers:"
                iFileNumber = FreeFile
                strFile = strDir & strYYYYMMDD & "." & objDatabase.Name & "_Tables.sql"
                Open strFile For Output As #iFileNumber
                i2 = 0
                For Each objTab In objDatabase.Tables
                    If Not objTab.SystemObject Then
                        i2 = i2 + 1
                        StatusMessage "    - Generating T-SQL code for Table " & CStr(i2) & ": " & objTab.Name
                        strScript = objTab.Script(ScriptType:=cTableScriptOptions, Script2Type:=IIf(bScriptDBFullText, SQLDMOScript2_FullTextIndex, SQLDMOScript2_Default))
                        DoEvents
                        Print #iFileNumber, strScript
                        DoEvents
                    End If
                Next objTab
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Tables scripted."
                DoEvents
            End If
            
            If bScriptDBViews Then
                'Script Views
                StatusMessage "  - Generating scripts for Views:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_Views.sql" For Output As #iFileNumber
                i2 = 0
                For Each objView In objDatabase.Views
                    If Not objView.SystemObject Then
                        i2 = i2 + 1
                        StatusMessage "    - Generating T-SQL code for View " & CStr(i2) & ": " & objView.Name
                        strScript = objView.Script(ScriptType:=cScriptOptions)
                        DoEvents
                        Print #iFileNumber, strScript
                        DoEvents
                    End If
                Next objView
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Views scripted."
                DoEvents
            End If
                
            If bScriptDBSPs Then
                'Script Stored Procedures
                StatusMessage "  - Generating scripts for Stored Procedures:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_Procs.sql" For Output As #iFileNumber
                i2 = 0
                For Each objProc In objDatabase.StoredProcedures
                    If Not objProc.SystemObject Then
                        i2 = i2 + 1
                        StatusMessage "    - Generating T-SQL code for Procedure " & CStr(i2) & ": " & objProc.Name
                        strScript = objProc.Script(ScriptType:=cScriptOptions)
                        DoEvents
                        Print #iFileNumber, strScript
                        DoEvents
                    End If
                Next objProc
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Stored Procedures scripted."
                DoEvents
            End If
            
            If bScriptDBRules Then
                'Script Rules
                StatusMessage "  - Generating scripts for Rules:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_Rules.sql" For Output As #iFileNumber
                i2 = 0
                For Each objRule In objDatabase.Rules
                    i2 = i2 + 1
                    StatusMessage "    - Generating T-SQL code for Rule " & CStr(i2) & ": " & objRule.Name
                    strScript = objRule.Script(ScriptType:=cScriptOptions)
                    DoEvents
                    Print #iFileNumber, strScript
                    DoEvents
                Next objRule
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Rules scripted."
                DoEvents
            End If
            
            If bScriptDBDefaults Then
                'Script Defaults
                StatusMessage "  - Generating scripts for Defaults:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_Defaults.sql" For Output As #iFileNumber
                i2 = 0
                For Each objDefault In objDatabase.Defaults
                    i2 = i2 + 1
                    StatusMessage "    - Generating T-SQL code for Default " & CStr(i2) & ": " & objDefault.Name
                    strScript = objDefault.Script(ScriptType:=cScriptOptions)
                    DoEvents
                    Print #iFileNumber, strScript
                    DoEvents
                Next objDefault
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Defaults scripted."
                DoEvents
            End If
            
            If bScriptDBUsers Then
                'Script Users
                StatusMessage "  - Generating scripts for Users:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_Users.sql" For Output As #iFileNumber
                i2 = 0
                For Each objUser In objDatabase.Users
                    If Not objUser.SystemObject Then
                        i2 = i2 + 1
                        StatusMessage "    - Generating T-SQL code for User " & CStr(i2) & ": " & objUser.Name
                        strScript = objUser.Script(ScriptType:=cScriptOptions, Script2Type:=SQLDMOScript2_LoginSID)
                        DoEvents
                        Print #iFileNumber, strScript
                        DoEvents
                    End If
                Next objUser
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Users scripted."
                DoEvents
            End If
            
            If bScriptDBRoles Then
                'Script Database Roles
                StatusMessage "  - Generating scripts for Database Roles:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_DBRoles.sql" For Output As #iFileNumber
                i2 = 0
                For Each objRole In objDatabase.DatabaseRoles
                    If Not objRole.IsFixedRole Then
                        i2 = i2 + 1
                        StatusMessage "    - Generating T-SQL code for Database Role " & CStr(i2) & ": " & objRole.Name
                        strScript = objRole.Script(ScriptType:=cScriptOptions)
                        DoEvents
                        Print #iFileNumber, strScript
                        DoEvents
                    End If
                Next objRole
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " Database Roles scripted."
                DoEvents
            End If
            
            If bScriptDBUDTs Then
                'Script User Defined Datatypes
                StatusMessage "  - Generating scripts for User Defined Datatypes:"
                iFileNumber = FreeFile
                Open strDir & strYYYYMMDD & "." & objDatabase.Name & "_UDTs.sql" For Output As #iFileNumber
                i2 = 0
                For Each objUDT In objDatabase.UserDefinedDatatypes
                    i2 = i2 + 1
                    StatusMessage "    - Generating T-SQL code for User Defined Datatype " & CStr(i2) & ": " & objUDT.Name
                    strScript = objUDT.Script(ScriptType:=cScriptOptions)
                    DoEvents
                    Print #iFileNumber, strScript
                    DoEvents
                Next objUDT
                Close #iFileNumber
                StatusMessage "  * " & CStr(i2) & " User Defined Datatypes scripted."
                DoEvents
            End If
            
            StatusMessage "* Database " & objDatabase.Name & " scripted."
NextDatabase:
        Next objDatabase
        StatusMessage CStr(i) & " Databases scripted."
    End If
    
    StatusMessage "Ready."
    Exit Sub
    
ErrorHandler:       ' Error-handling routine.
    StatusMessage "Error: 0x" & Hex$(Err.Number) & vbTab & Error(Err.Number)
    Select Case Err.Number
        Case &H35           'File does not exist
            StatusMessage "Error deleting file. Resuming with next one."
            Resume Next
        Case &H80030002     'DTS Package version number to high
            StatusMessage "DTS Package " & strPackageName & " has wrong version number. Package skipped."
            Resume NextDTSPackage
        Case &H80045510     'Nonexistant database
            StatusMessage "Database " & vDatabases(j) & " does not exist. Resuming with next one."
            i = i - 1
            Resume NextDatabase
        Case Else           'Unanticipated error
            If bNoGUI Then
                If strCheckPoint = "databases" Then
                    StatusMessage "Error scripting database. Resuming with next one."
                    Resume NextDatabase
                Else
                    StatusMessage "Unanticipated error."
                    StatusMessage "Checkpoint: " & strCheckPoint
                    StatusMessage "Aborting program."
                    SaveLog strLogFile
                End If
            Else
                msgResult = MsgBox("An SQL-DMO error occurred. The error has been written to the log. " & _
                                   "Do you want to abort the program?" & vbNewLine & vbNewLine & _
                                   "Choose 'Abort' to abort the program, 'Retry' to retry the action that caused " & _
                                   "the error, or 'Ignore' to stop scripting this database and continue with " & _
                                   "the next one (if any). ", vbExclamation Or vbAbortRetryIgnore, "Error!")
                Select Case msgResult
                    Case vbAbort
                        Close #iFileNumber
                        StatusMessage "Program aborted by user."
                        SaveLog strLogFile
                        Unload frmMain
                        Set frmMain = Nothing
                        End
                    Case vbRetry
                        StatusMessage "Retrying..."
                        Resume
                    Case vbIgnore
                        Close #iFileNumber
                        If strCheckPoint = "databases" Then
                            StatusMessage "Ignoring error, resuming with next database."
                            Resume NextDatabase
                        Else
                            StatusMessage "Error cannot be ignored. Aborting program."
                            MsgBox "Sorry, unable to continue from this point. Program will be terminated instead.", _
                                   vbCritical, "Critical Error!"
                            SaveLog strLogFile
                            Unload frmMain
                            Set frmMain = Nothing
                            End
                        End If
                End Select
            End If
    End Select
End Sub

Private Sub Main()
    Dim vaSwitches As Variant, vTemp As Variant
    Dim strSwitch As String, strValue As String
    Dim i As Integer
    
    'Parse out the command-line parameters (if any)
    vaSwitches = Split(Command$, "/")
    On Error Resume Next
    For i = 1 To UBound(vaSwitches)
        vTemp = Split(CStr(vaSwitches(i)), "=")
        strSwitch = UCase$(Trim$(CStr(vTemp(0))))
        strValue = Trim$(CStr(vTemp(1)))
        Select Case strSwitch
            Case "S", "SERVER"                  'Servername
                strServerNameSW = strValue
            Case "U", "USER"                    'Login
                strLoginSW = strValue
            Case "P", "PW", "PASSWORD"          'Password
                strPasswordSW = strValue
            Case "DB", "DATABASE"               'Databases (comma-delimited list)
                vDatabasesSW = Split(strValue, ",")
            Case "DBA", "DBAOPTIONS"            'DBA Scriptiong options. "ALL" or any combination of A, D, L and J
                If UCase$(strValue) = "ALL" Then
                    bSaveDTSPackagesSW = True
                    bScriptAlertsSW = True
                    bScriptServerLoginsSW = True
                    bScriptAgentJobsSW = True
                    bScriptBackupDevicesSW = True
                Else
                    If InStr(UCase$(strValue), "D") > 0 Then bSaveDTSPackagesSW = True
                    If InStr(UCase$(strValue), "A") > 0 Then bScriptAlertsSW = True
                    If InStr(UCase$(strValue), "L") > 0 Then bScriptServerLoginsSW = True
                    If InStr(UCase$(strValue), "J") > 0 Then bScriptAgentJobsSW = True
                    If InStr(UCase$(strValue), "B") > 0 Then bScriptBackupDevicesSW = True
                End If
            Case "DEL"                          'Number of weeks to keep old files
                iDelWeeksSW = CInt(strValue)
                bDelOldFilesSW = True
            Case "DIR", "DEST", "DESTDIR"       'Destination directory for the scripts
                strDestDirSW = strValue
                If Right$(strDestDirSW, 1) <> "\" Then strDestDirSW = strDestDirSW & "\"
            Case "BG", "BACK", "BACKGROUND"
                bRunUnAttendedSW = True
        End Select
    Next i
    DoEvents
    'Determine if the program will be run unattended
    If (Len(strServerNameSW) = 0 Or Len(strDestDirSW) = 0) Or _
       (IsEmpty(vDatabasesSW) And Not bRunUnAttendedSW) Then       'GUI
        bNoGUI = False
        frmMain.Show
    Else        'Unattended
        bNoGUI = True
        With objServer
            .Name = strServerNameSW
            .ApplicationName = App.Title
            DoEvents
            strLogFile = strDestDirSW & Format(Date, "yyyymmdd") & "." & objServer.Name & "_Log.txt"
            If Len(strLoginSW) = 0 Then
                .Login = ""
                .Password = ""
                .LoginSecure = True
                StatusMessage "Using Trusted Connection"
            Else
                .LoginSecure = False
                .Login = strLoginSW
                .Password = strPasswordSW
                StatusMessage "Using Login: " & strLoginSW
            End If
            On Error GoTo ErrHandler
            StatusMessage "Connecting to: " & objServer.Name
            .Connect
            DoEvents
            GenerateScripts strServerNameSW, strDestDirSW, vDatabasesSW, .LoginSecure, _
                            strLoginSW, strPasswordSW, bDelOldFilesSW, iDelWeeksSW, _
                            True, True, True, True, True, True, True, True, True, _
                            bSaveDTSPackagesSW, bScriptAlertsSW, bScriptAgentJobsSW, _
                            bScriptServerLoginsSW, bScriptBackupDevicesSW
            DoEvents
            SaveLog strLogFile
            .Close
            DoEvents
        End With
        Set objServer = Nothing
    End If
    Exit Sub
    
ErrHandler:
    StatusMessage "Error: 0x" & Hex$(Err.Number) & vbTab & Error(Err.Number)
    StatusMessage "Failed to connect to the server. Program aborted."
    SaveLog strLogFile
End Sub

